unit chain;

interface

implementation
uses
{$IFDEF LINUX}
      Libc,
{$ENDIF}
      QForms, SysUtils,
      listcoll,base,variabl,struct,express,
      helpctex,texthand,control,sconsts,statemen;


{$IFDEF LINUX}


function ShellExecNoWait(s1,s2:string):boolean;
var
   pid:integer;
begin
   result:=true;
   pid:=vfork();
   if pid=0 then
      begin
        execlp(PChar(s1), PChar(s1), PChar(s2), nil);
        Libc._exit(-1);
      end
   else if pid=-1 then
                        setexception(OutOfmemory);
end;


function ShellExec(const s1,s2:string; opWaitFor:LongBool):boolean;
var
   s:string;
begin
   if opWaitFor then
    begin
      s:=s1 + ' ' + s2;
      result:=(Libc.system(PChar(s))=0);
    end
   else
    result:=ShellExecNoWait(s1,s2)
end;

{$ELSE}
function ShellExec(s1,s2:string; opWaitFor:boolean):boolean;
begin
   result:=false  // dummy
end;
{$ENDIF}

type
  TEXECUTE=class(TStatement)
     exp1:TPrincipal;
     params:TListCollection;
     opWaitFor:boolean;
     ChainSt:boolean;

    constructor create(prev,eld:TStatement; opWaitFor0:boolean);
    procedure exec;override;
    destructor destroy;override;
  end;


constructor TEXECUTE.create(prev,eld:TStatement; opWaitFor0:boolean);
begin
    inherited create(prev,eld);
    opWaitFor:=opWaitFor0;
    if token='NOWAIT' then
                      begin opWaitFor:=false; gettoken end;
    exp1:=SExpression;
    params:=TListCollection.create;
    if token='WITH' then
       begin
          gettoken;
          check('(',IDH_CHAIN);
          repeat
             params.insert(article);
          until test(',')=false;
          check(')',IDH_CHAIN);
       end;
end;

destructor TEXECUTE.destroy;
begin
   exp1.free;
   params.free;
   inherited destroy;
end;

procedure TEXECUTE.exec;
var
   s1,s2,s:AnsiString;
   i:integer;
   ToChain:boolean;
begin
   ToChain:=Chainst;
   s1:=exp1.evalS;
   s2:='';
   if not FileExists(s1) and (ExtractFileExt(s1)='') then
                  s1:=s1 + BASExt;
   if not FileExists(s1)  then
      begin
        s:=ExtractFilePath(Application.ExeName)+s1;
        if FileExists(s) then
           s1:=s
        else
           //s1:=FileSearch(s1,GetEnvironmentVariable('PATH'))
           ;
      end;
   if (s1<>'') and FileExists(s1) then
        begin
            if (ExtractFileExt(s1)=BASExt) then
               begin
                   s2:=s1;
                   s1:=Application.ExeName;
               end
          else
             ToChain:=false;
            i:=0;
         if ToChain then
            begin
               ChainFile:=s2;
               with params do
                 while i<count do
                   begin
                     ChainParams.Add(TPrincipal(items[i]).str);
                     inc(i)
                   end;
            end
          else
            begin
              if s2<>'' then
                 s2:=AnsiQuotedStr(s2,'"')+' ';
              with params do
                while i<count do
                  begin
                     s2:=s2 + TPrincipal(items[i]).str2 +' ' ;
                     inc(i)
                  end;
              if ShellExec(PChar(s1),PChar(s2),opWaitFor) then
              else
                 setexception(10005);
            end;
      end
   else
      setexception(10005);


end;

function EXECUTEst(prev,eld:TStatement):TStatement;far;
begin
    EXECUTEst:=TEXECUTE.CREATE(prev,eld, true);
end;

type
    TCHAIN=class(TEXECUTE)
      constructor create(prev,eld:TStatement);
      procedure exec;override;
    end;

function CHAINst(prev,eld:TStatement):TStatement;far;
begin
    CHAINst:=TCHAIN.CREATE(prev,eld);
end;

constructor TCHAIN.create(prev,eld:TStatement);
begin
   inherited create(prev,eld,false);
   Chainst:=true;
end;

procedure TCHAIN.exec;
begin
   inherited exec ;
   raise EStop.create;
end;

{*************}
{registeration}
{*************}

procedure statementTableinit;far;
begin
   StatementTableInitImperative('CHAIN',CHAINst);
   StatementTableInitImperative('EXECUTE',EXECUTEst);
end;

procedure functiontableInit;far;
begin
end;


begin
   tableInitProcs.accept(statementTableinit);
   tableInitProcs.accept(FunctionTableInit);
end.
