unit mdiframe;

(***************************************)
(* Copyright (C) 2003, SHIRAISHI Kazuo *)
(***************************************)

interface

uses Qtypes, Classes, QGraphics, QForms, QControls, QMenus,
     SysUtils,QExtCtrls, QStdCtrls, QDialogs,
     QComCtrls,  QImgList,
     base, mdiedit, textfrm, paintfrm, myutils;

type
  TFrameForm = class(TForm)
    MainMenu1: TMainMenu;
    OpenDialog1: TOpenDialog;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Window1: TMenuItem;
    Cascade1: TMenuItem;
    Tile1: TMenuItem;
    Help1: TMenuItem;
    Option1: TMenuItem;
    option2: TMenuItem;
    FontDialog1: TFontDialog;
    About1: TMenuItem;
    TextOut1: TMenuItem;
    Graphic1: TMenuItem;
    N4: TMenuItem;
    Contents1: TMenuItem;
    N5: TMenuItem;
    AutoCorrect1: TMenuItem;
    Syntax1: TMenuItem;
    Compatibility1: TMenuItem;
    N6: TMenuItem;
    N3: TMenuItem;
    Font1: TMenuItem;
    StatusBar1: TStatusBar;
    ToolbarImages: TImageList;
    ToolBar1: TToolBar;
    tbNew: TToolButton;
    TBOpen: TToolButton;
    TBSave: TToolButton;
    TBPrint: TToolButton;
    ToolButton15: TToolButton;
    TBCut: TToolButton;
    TBCopy: TToolButton;
    TBPaste: TToolButton;
    TBUndo: TToolButton;
    ToolButton12: TToolButton;
    TBRun: TToolButton;
    TBStep: TToolButton;
    TBBreak: TToolButton;
    ToolButton16: TToolButton;
    TBHelp: TToolButton;
    ShowToolBar1: TMenuItem;
    TBDecimal: TToolButton;
    TBHighPrecision: TToolButton;
    TBBinary: TToolButton;
    TBDeg: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton3: TToolButton;
    TBComplex: TToolButton;
    L1: TMenuItem;
    N1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Debug1: TMenuItem;
    ButtonFrame1: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    TBRational: TToolButton;
    N10: TMenuItem;
    AutoFormat1: TMenuItem;
    N7: TMenuItem;
    S1: TMenuItem;
    I1: TMenuItem;
    MenuFont1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Break1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure option2Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure TextOut1Click(Sender: TObject);
    procedure Graphic1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure Search1Click(Sender: TObject);
    procedure compatibility1Click(Sender: TObject);
    procedure AutoCorrect1Click(Sender: TObject);
    procedure Syntax1Click(Sender: TObject);
    procedure TBOpenClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure TBPrintClick(Sender: TObject);
    procedure TBCutClick(Sender: TObject);
    procedure TBCopyClick(Sender: TObject);
    procedure TBPasteClick(Sender: TObject);
    procedure TBUndoClick(Sender: TObject);
    procedure TBRunClick(Sender: TObject);
    procedure TBStepClick(Sender: TObject);
    procedure TBBreakClick(Sender: TObject);
    procedure TBHelpClick(Sender: TObject);
    procedure ShowToolBar1Click(Sender: TObject);
    procedure TBDecimalClick(Sender: TObject);
    procedure TBHighPrecisionClick(Sender: TObject);
    procedure TBBinaryClick(Sender: TObject);
    procedure TBDegClick(Sender: TObject);
    procedure TBComplexClick(Sender: TObject);
    procedure L1Click(Sender: TObject);
    procedure Debug1Click(Sender: TObject);
    procedure ButtonFrame1Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure TBRationalClick(Sender: TObject);
    procedure AutoFormat1Click(Sender: TObject);
    procedure I1Click(Sender: TObject);
    procedure tbNewClick(Sender: TObject);
    procedure MenuFont1Click(Sender: TObject);
  private
       NewPrograms:Integer;
    procedure SetOptionMenues(b:byte);
    procedure SetPrecisionButtons(mode:tpPrecision) ;
  public
    function OpenTextFile(Filename: string):TEditForm;
    procedure OpenFile(FileName: String);
    function NewNoName:string;
    function ValidComponent(component:TComponent):boolean;
    procedure SetStatusBar1(OverWriteMode:boolean);
    procedure SetAngleButtons(s:boolean);
    procedure ActiveFormChange(Sender: TObject);
    procedure SetBreakMessage;
end;

var
  FrameForm: TFrameForm;
var
  ToTerminate:boolean=false;
  ToOpen:boolean=false;
  ToOpenFile:string='';

implementation
 uses IniFiles,  Helpintfs,
  optiondg,compadlg,toolfrm,texthand, optina,syntaxdg,tracefrm,
  debugdg, fkeydlg, stringdg,struct,afdg,sconsts, about;

{$R *.xfm}


var
  InitialDir:ansistring='.';


procedure TFrameForm.FormCreate(Sender: TObject);
begin
    SetFontSub(Application.Font, MainMenu1);

    Caption:=AppTitle;
    OpenDialog1.Title:=s_OpenFile;
    SaveDialog1.Title:=s_SaveFile;
    with OpenDialog1 do
       Options:=Options + [ofHideReadOnly];
    with SaveDialog1 do
       Options:=Options + [ofHideReadOnly];


    Screen.OnActiveFormChange := ActiveFormChange;

    NewPrograms:=0;


    with TMyIniFile.create('Frame') do
       begin
         BreakKey:=ReadString('BreakKey',BreakKey)[1];
         Left:=ReadInteger('Left',Left);
         Top:=ReadInteger('Top',Top);
         Width:=ReadInteger('Width',Width);
         Height:=ReadInteger('Height',Height);
         HideSyntaxMenu:=ReadBool('HideSyntaxMenu',HideSyntaxMenu);
         NoBackUp:=ReadBool('NoBackUp',NoBackUp);
         BasExt:=ReadString('BasExt',BasExt);
         LibExt:=ReadString('LibExt',LibExt);
         InitialDir:=ReadString('InitialDir', InitialDir);
         OpenDialog1.InitialDir:=InitialDir;
         InitialDir:=ReadString('InitialDir', InitialDir);
         SaveDialog1.InitialDir:=InitialDir;
         if ToolBar1.Flat<>ReadBool('Flat',ToolBar1.flat) then
                                   ButtonFrame1Click(self);
         if ToolBar1.visible <> ReadBool('ToolBar',ToolBar1.visible) then
                                   ShowToolBar1Click(self);

         if ReadOnly then
            I1.Enabled:=false;
         free
       end;

     if permitMicrosoft then MinimalBasic:=true;
     SetOptionMenues(0);
     if MinimalBasic then SetOptionMenues(1);
     if permitMicrosoft then  SetOptionMenues(2);
     if HideSyntaxMenu then
         begin
             syntax1.enabled:=false;
             MinimalBasic:=false;
             PermitMicrosoft:=false;
             SetOptionMenues(0);
         end;
   FrameForm.StatusBar1.Panels[3].text:=statusBarMems3;

end;

procedure TFrameForm.FormDestroy(Sender: TObject);
begin
      with TMyIniFile.create('Frame') do
      begin
          WriteInteger('Left',Left);
          WriteInteger('Top',Top);
          WriteInteger('Width',Width);
          WriteInteger('Height',Height);
          WriteBool('Flat',ToolBar1.Flat);
          WriteBool('ToolBar',ToolBar1.visible);
          Free
      end;

end;


procedure TFrameForm.ActiveFormChange(Sender: TObject);
begin
end;

function TFrameForm.OpenTextFile(FileName: string):TEditForm;
const DefaultText:string=EOL+'END'+EOL;
begin

  Hint:='';
  if (DefaultEditForm<>nil)
      and (executingNow=false)
      and (DefaultEditForm.memo1.Modified=false)
      and (DefaultEditForm.memo1.lines.text<>DefaultText) then
            begin
                   DefaultEditForm.free;
                  { DefaultEditForm:=nil; }
                   NewPrograms:=0;
           end;
  Cascade;
  Result:=TEditForm.Create(self);
  with Result do
    if FileName <> '' then
       try
         OpenFile(FileName)
       except
         MessageDlg(s_Extype9003+EOL+FileName,mtError, [mbOk],0);
         Result.release;
         Result:=OpenTextFile('');
       end
    else
       begin
          Caption:=NewNoName+BasExt;
          if not permitMicrosoft then
             Memo1.seltext:=DefaultText;
          Memo1.SelStart:=0;
          Memo1.Modified:=false;
       end;
  if (CompareStr(UpperCase(ExtractFileExt(FileName)), BASExt) = 0) or
      (FileName = '') then
     begin
       result.N7.visible:=false; Result.WordWrap1.visible:=false end ;

end;

procedure TFrameForm.OpenFile(FileName: String);
begin
           OpenTextFile(FileName)
end;

procedure TFrameForm.Tile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TFrameForm.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TFrameForm.New1Click(Sender: TObject);
begin
  OpenTextFile('');
end;

procedure TFrameForm.Open1Click(Sender: TObject);
begin
  OpenDialog1.Filter :=
      s_program+'|*'+BasExt+';*.BAS;*.bak;*.tru|'
      +s_Library+'|*'+LibExt+'|'
      +s_TextFile+'|*.txt;*.log';
  OpenDialog1.DefaultExt :=copy(BasExt,2,3);
  if OpenDialog1.Execute then
     OpenFile(OpenDialog1.FileName);
end;


procedure TFrameForm.CloseAll1Click(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to MDIChildCount -1 do
    MDIChildren[0].Close
end;

procedure TFrameForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.Break1Click(Sender: TObject);
begin
    ctrlBreakHit:=true;
    SetBreakMessage;
end;

function TFrameForm.ValidComponent(component:TComponent):boolean;
var
   i:integer;
begin
   ValidComponent:=true;
   i:=ComponentCount;
   while i>0 do
       begin
           dec(i);
           if Components[i]=component then exit
       end;
   ValidComponent:=false
end;

procedure TFrameForm.Font1Click(Sender: TObject);
var
   i:integer;
begin
  FontDialog1.Font:=EditorFont;
  if FontDialog1.Execute then
     begin
        EditorFont.assign(FontDialog1.Font);

        for i:=0 to MdiChildCount-1 do
          if MdiChildren[i] is TEditForm then
             (MdiChildren[i] as TEditForm).Memo1.font:=EditorFont;

        end;
end;

procedure TFrameForm.option2Click(Sender: TObject);
begin
   Optiondg.setoption;
   SetPrecisionButtons(InitialPrecisionMode0);
end;

procedure TFrameForm.SetPrecisionButtons(mode:tpPrecision);
begin
   case Mode of
      PrecisionNormal:  TBDecimal.down:=true;
      PrecisionHigh:    TBHighprecision.Down:=true;
      PrecisionNative:  TBBinary.down:=true;
      PrecisionComplex: TBComplex.down:=true;
      PrecisionRational:TBRational.down:=true;
   end;
end;

procedure TFrameForm.SetAngleButtons(s:boolean);
begin
   TBdeg.down:=s;
end;

function TFrameForm.NewNoName:string;
var
   s:string;
begin
    inc(NewPrograms);
    str(NewPrograms,s);
    NewNoName:='NoName'+s;
end;


procedure TFrameForm.About1Click(Sender: TObject);
begin

       AboutBox.ShowModal

end;

procedure TFrameForm.TextOut1Click(Sender: TObject);
begin
    with TextForm do
      begin
        if WindowState=wsMinimized then
           WindowState:=wsNormal;
        BringToFront
      end;
end;

procedure TFrameForm.Graphic1Click(Sender: TObject);
begin
    with Paintform do
      begin
        if WindowState=wsMinimized then
           WindowState:=wsNormal;
        BringToFront;
        Repaint;
      end;
end;

procedure TFrameForm.Contents1Click(Sender: TObject);
begin
   Application.KeyWordHelp('')
   //Application.HelpCommand(11,0)
end;

procedure TFrameForm.Search1Click(Sender: TObject);
begin
     Application.KeywordHelp('')
     //Application.HelpCommand(HELP_PARTIALKEY,0)
end;

procedure TFrameForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   windowState:=wsNormal;
   toolbox.close;
end;




procedure TFrameForm.compatibility1Click(Sender: TObject);
begin
   setCompatibility
end;


procedure TFrameForm.AutoCorrect1Click(Sender: TObject);
var
   i:integer;
begin
   with optionAC do
   begin
      for i:=0 to ac_end do
          CheckListBox1.checked[i]:=AutoCorrect[i];
      OptionAC.CheckListBox2.Visible:=not MinimalBasic;
      OptionAC.Label2.Visible:=not MinimalBasic;
      CheckListBox2.checked[0]:=InsertDIMst;
      CheckListBox2.checked[1]:=(InitialOptionBase=0);
      CheckListBox3.checked[0]:=InitialAngleDegrees;
      CheckListBox4.Checked[0]:=AutoIndent;
      if showModal=mrOK then
      begin
         for i:=0 to ac_end do
            AutoCorrect[i]:=CheckListBox1.checked[i];
         InsertDIMst:=CheckListBox2.checked[0];
         Boolean(InitialOptionBase):= not CheckListBox2.checked[1];
         InitialAngleDegrees:=CheckListBox3.checked[0];
         setAngleButtons(InitialAngleDegrees);
         AutoIndent:=CheckListBox4.Checked[0];
      end;
   end
end;


procedure TFrameForm.SetOptionMenues(b:byte);
const
    mes:array[0..2]of string=(s_Standard,s_Minimal,s_MS);
var
    s:boolean;
begin
   StatusBar1.Panels[2].text:=mes[b];
   case b of
      0,1:begin
            s:=true;
            setPrecisionButtons(InitialPrecisionMode0);
            SetAngleButtons(InitialAngleDegrees);
          end;
      else begin    {Microsoft BASIC}
            s:=false;
            setPrecisionButtons(PrecisionNative);
            SetAngleButtons(false);
          end;
    end;
    option2.enabled:=s;
    Compatibility1.enabled:=s;
    Autocorrect1.enabled:=s;
    TBDecimal.enabled:=s;
    TBHighPrecision.enabled:=s;
    TBComplex.enabled:=s;
    TBRational.enabled:=s;
    TBDeg.enabled:=s;
end;

procedure TFrameForm.Syntax1Click(Sender: TObject);
var
   b:byte;
begin
   with SyntaxDlg do
   begin
       b:=byte(MinimalBasic);
       RadioGroup1.ItemIndex:=b;
       if permitMicrosoft then RadioGroup1.ItemIndex:=2;
       CheckListBox1.checked[0]:=OptionExplicit;

       if ShowModal=mrOK then
         begin
            MinimalBasic:=RadioGroup1.Itemindex>0;
            permitMicrosoft:=(RadioGroup1.Itemindex=2);
            SetOptionMenues(RadioGroup1.ItemIndex);
            OptionExplicit:=(CheckListBox1.checked[0]) and not MinimalBasic;
         end;
   end;
end;



procedure TFrameForm.SetStatusBar1(OverWriteMode:boolean);
begin
         if OverWriteMode then
            begin
              StatusBar1.Panels[0].text:=s_Overwrite;
              StatusBar1.Panels[0].Bevel:=pbRaised;
            end
         else
            begin
              StatusBar1.Panels[0].text:=s_insert;
              StatusBar1.Panels[0].Bevel:=pbLowered;
            end;
end;


procedure TFrameForm.TBOpenClick(Sender: TObject);
begin
   Open1Click(sender)
end;

procedure TFrameForm.TBSaveClick(Sender: TObject);
var
   Form:TForm;
begin
   Form:=ActiveMDIChild;
   if (Form<>nil) and (Form is TEditForm) then TEditForm(Form).SaveAs1click(sender)
end;

procedure TFrameForm.TBPrintClick(Sender: TObject);
var
   Form:TForm;
begin
   Form:=ActiveMDIChild;
   if (Form<>nil) and (Form is TEditForm) then TEditForm(Form).Print1click(sender)
end;

procedure TFrameForm.TBCutClick(Sender: TObject);
var
   Form:TForm;
begin
   Form:=ActiveMDIChild;
   if (Form<>nil) and (Form is TEditForm)then TEditForm(Form).Cut1click(sender)
end;

procedure TFrameForm.TBCopyClick(Sender: TObject);
var
   Form:TForm;
begin
   Form:=ActiveMDIChild;
   if (Form<>nil) and (Form is TEditForm) then TEditForm(Form).Copy1click(sender)
end;


procedure TFrameForm.TBPasteClick(Sender: TObject);
var
   Form:TForm;
begin
   Form:=ActiveMDIChild;
   if (Form<>nil) and (Form is TEditForm) then TEditForm(Form).Paste1click(sender)
end;


procedure TFrameForm.TBUndoClick(Sender: TObject);
var
   Form:TForm;
begin
   Form:=ActiveMDIChild;
   if (Form<>nil) and (Form is TEditForm) then TEditForm(Form).Undo1click(sender)
end;

procedure TFrameForm.TBRunClick(Sender: TObject);
var
   Form:TForm;
begin
   Form:=ActiveMDIChild;
   if (Form<>nil) and (Form is TEditForm) then TEditForm(Form).Run2click(sender)
end;


procedure TFrameForm.TBStepClick(Sender: TObject);
var
   Form:TForm;
begin
   Form:=ActiveMDIChild;
   if (Form<>nil) and (Form is TEditForm) then TEditForm(Form).Step1click(sender)
end;



procedure TFrameForm.TBBreakClick(Sender: TObject);
var
   Form:TForm;
begin
   Form:=ActiveMDIChild;
   if (Form<>nil) and (Form is TEditForm) then TEditForm(Form).Break1click(sender)
end;

procedure TFrameForm.TBHelpClick(Sender: TObject);
begin
    Contents1Click(sender)
end;

procedure TFrameForm.TBDecimalClick(Sender: TObject);
begin
     InitialPrecisionMode0:=PrecisionNormal
end;

procedure TFrameForm.TBHighPrecisionClick(Sender: TObject);
begin
     InitialPrecisionMode0:=PrecisionHigh
end;

procedure TFrameForm.TBBinaryClick(Sender: TObject);
begin
    InitialPrecisionMode0:=PrecisionNative
end;

procedure TFrameForm.TBComplexClick(Sender: TObject);
begin
    InitialPrecisionMode0:=PrecisionComplex
end;

procedure TFrameForm.TBRationalClick(Sender: TObject);
begin
    InitialPrecisionMode0:=PrecisionRational
end;


procedure TFrameForm.TBDegClick(Sender: TObject);
begin
   InitialAngleDegrees:=not InitialAngleDegrees;
end;

procedure TFrameForm.L1Click(Sender: TObject);
begin
    with TraceForm do
      begin
        visible:=true;
        if WindowState=wsMinimized then
           WindowState:=wsNormal;
        BringToFront
      end;
end;

procedure TFrameForm.Debug1Click(Sender: TObject);
begin
     DebugDlg.setFont;
end;

procedure TFrameForm.ShowToolBar1Click(Sender: TObject);
begin
    with ShowToolBar1 do
      begin
        Checked:=not checked;
        ToolBar1.visible:=checked;
        ButtonFrame1.Enabled:=checked;
      end;
end;

procedure TFrameForm.ButtonFrame1Click(Sender: TObject);
begin
   with ButtonFrame1 do
   begin
      checked:=not checked;
      Toolbar1.Flat:=not checked;
   end;

end;

procedure TFrameForm.N9Click(Sender: TObject);
begin
   FkeysDlg.Execute
end;

procedure TFrameForm.C1Click(Sender: TObject);
begin
  StringDlg.execute
end;


procedure TFrameForm.AutoFormat1Click(Sender: TObject);
begin
   AFDg.SetAutoFormat;
end;

procedure TFrameForm.SetBreakMessage;
begin
  StatusBar1.Panels[3].text:=s_To_Break;
  StatusBar1.update;
end;

procedure TFrameForm.FormShow(Sender: TObject);
begin
  if ToTerminate then
     Application.Terminate  ;

  if ToOpen then
     begin
       TextForm.WindowState:=wsMinimized;
       PaintForm.WindowState:=wsMinimized;
       TraceForm.Visible:=false;  //.WindowState:=wsMinimized;
       DefaultEditForm:=FrameForm.OpenTextFile(ToOpenFile);
       Application.ProcessMessages;

       ToOpen:=false;
       FrameForm.BringToFront;
     end;

end;

procedure TFrameForm.I1Click(Sender: TObject);
begin
  InitializeEnv;
end;

procedure TFrameForm.tbNewClick(Sender: TObject);
begin
     New1Click(Sender)
end;


procedure TFrameForm.MenuFont1Click(Sender: TObject);
begin
  FontDialog1.Font.assign(Application.Font);
  if FontDialog1.Execute then
    begin

        if c_language='J' then
                          FontDialog1.Font.CharSet:=fcsSet_Ja;
        
        Application.Font.assign(FontDialog1.Font);
        SetFontSub(FontDialog1.Font,FrameForm.MainMenu1);
        SetFontSub(FontDialog1.Font,TextForm.MainMenu1);
        SetFontSub(FontDialog1.Font,PaintForm.MainMenu1);
        SetFontSub(FontDialog1.Font,TraceForm.MainMenu1);
    end;
end;

end.
