unit myutils;

(***************************************)
(* Copyright (C) 2003, SHIRAISHI Kazuo *)
(***************************************)


interface
uses QDialogs,QStdCtrls;

  function isDBCSLeadByte(ch:byte):boolean;
  function LineFromChar(memo:TMemo; n:integer):integer; //line index from char pos
  function LineIndex(memo:Tmemo; n:integer):integer;    //line index to char pos
  function WideLen(s:string; i:integer):integer;
  function WideLength(s:string ):integer;
  function isTrueFile(s:string):boolean;
  procedure NotAvailableMessage;



implementation
uses
{$IFDEF LINUX}
   LibC,
{$ENDIF}
   SysUtils,
   Base;

function  isDBCSLeadByte(ch:byte):boolean;
  begin
     result:=char(ch) in LeadBytes;
  end;

function LineFromChar(memo:TMemo; n:integer):integer; //line index from char pos
var
   svSelStart:integer;
begin
  with memo do
  begin
    Lines.BeginUpdate;
    svSelStart:=SelStart;
    SelStart:=n;
    Sellength:=0;
    result:=CaretPos.line;
    SelStart:=svSelStart;
    Lines.EndUpdate;
  end;
end;


function LineIndex(memo:Tmemo; n:integer):integer;    //line index to char pos
var
  Pos:TCaretPos;
  svSelStart:integer;
begin
  result:=0;
  Pos.Line:=n;
  Pos.Col:=0;
  with memo do
  begin
    Lines.BeginUpdate;
    svSelStart:=SelStart;
    CaretPos:=Pos;
    result:=selStart;
    SelStart:=svSelStart;
    lines.endUpdate;
  end;
end;

function WideLen(s:string; i:integer):integer;
var
   w:WideString;
begin
   w:=copy(s,1,i);
   result:=length(w);
end;

function WideLength(s:string):integer;
var
   w:WideString;
begin
   w:=s;
   result:=length(w);
end;

 procedure NotAvailableMessage;
begin
   Messagedlg('not available'#10'εǽѤǤޤ' ,mterror,[mbok],0)
end;


function isTrueFile(s:string):boolean;
{$IFDEF Linx}
var
  buf: TStatBuf;
begin
  result:=false;
  if STAT(PChar(s),buf) and S_ISREG(buf.st_mode) then
    result:=true
end;
{$ELSE}
begin
   result:=true;  //dummy
end;
{$ENDIF}


{$IFDEF LINUX}
procedure SetSysStackSize;
var
  rlim:rlimit;
begin
  if (getrlimit(RLIMIT_STACK, rlim)=0 )
     and (rlim.rlim_max>=$00800000) then
     begin
        rlim.rlim_cur:=$00800000;
        if setrlimit(RLIMIT_STACK, rlim)=0 then
           StackLimit:=$00400000;
     end;
end;
{$ELSE}
procedure SetSysStackSize;
begin
           StackLimit:=$00400000;
end;
{$ENDIF}


begin

 SetSysStackSize
end.

