unit printdlg;

interface

uses
   Types,Classes, SysUtils, QGraphics, QControls, QForms, QDialogs,
   QExtCtrls, QStdCtrls, QButtons, QComCtrls;

type
  TPrintDialog = class(TForm)
    OkButton: TBitBtn;
    cancelButton: TBitBtn;
    FontDialog1: TFontDialog;
    Panel1: TPanel;
    PrinterButton: TButton;
    FontButton: TButton;
    procedure PrinterButtonClick(Sender: TObject);
    procedure FontButtonClick(Sender: TObject);
  private
    { Private  }
  public
    procedure execute(memo1:TMemo);
  end;

var
  PrintDialog: TPrintDialog;
procedure PrintMemo(memo1:TMemo);

implementation
uses QPrinters,
     base,mdiframe,sconsts;
{$R *.xfm}

procedure PrintMemo(memo1:TMemo);
var
  x,y,dy:integer;
  i: Integer;
begin
  with Printer do
    begin
      printer.Canvas.Font.Assign(PrinterFont);
      BeginDoc;
      with Canvas do
      begin
         Brush.Color := clBlack;
         dy:=TextHeight(Memo1.Lines.Strings[0]);
         x:=0;
         y:=dy+dy;   //margin
         i:=0;
         while i<Memo1.Lines.Count do
           begin
             TextOut(x,y, Memo1.Lines.Strings[i]);
             inc(i);
             y:=y+dy;
             if y>pageHeight then
                begin
                  y:=dy;
                  NewPage;
                end;
           end;
      end;
      EndDoc;
    end;
end;


procedure TPrintDialog.execute(memo1:TMemo);
begin
  if showModal=mrOk then
    PrintMemo(Memo1);
end;

procedure TPrintDialog.PrinterButtonClick(Sender: TObject);
begin
   printer.ExecuteSetup;
end;

procedure TPrintDialog.FontButtonClick(Sender: TObject);
begin
   //FontDialog1.Device:=fdPrinter;
   FontDialog1.Font:=PrinterFont;
   if FontDialog1.Execute then
         PrinterFont.assign(FontDialog1.Font);

end;

end.
